#if !defined( _endian_h )
#define _endian_h

/* This defaults to a run time endian test.  You can define BIG_ENDIAN
   or LITTLE_ENDIAN appropriately to speed things up.

   LITTLE_ENDIAN is the broken one: 80x86s, VAXs
   BIG_ENDIAN is: most unix machines, RISC chips, 68000, etc

   The endianess is stored in macros:

         little_endian
   and   big_endian

   These boolean values can be checked in your code in C expressions.

   They should NOT be tested with conditional macro statements (#ifdef
   etc). use BIG_ENDIAN and LITTLE_ENDIAN for this, if they are defined.

   Careful use should ensure the compiler compiles out code where
   possible
*/

#if defined( BIG_ENDIAN )
   #define little_endian 0
#elif defined( LITTLE_ENDIAN )
   #define little_endian 1
#else
   #define little_endian ( (* (long*) "\1\0\0\0" ) == 1 )
#endif

#define big_endian ( ! little_endian )

#endif
